//+------------------------------------------------------------------+
//|                                                    mysqlTest.mq4 |
//|                                        Copyright  2012, vedroid |
//|                                                begpoug@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, vedroid"
#property link      "mailto: begpoug@gmail.com"

#include <mysql_v2.0.5.mqh>

string  host     = "127.0.0.1";
string  user     = "root";
string  pass     = "rootpass";
string  dbName   = "information_schema"; //      MySQL 
                                         // this table is in any MySQL server
int     port     = 3306;
int     socket   = 0;
int     client   = 0;

int     dbConnectId = 0;
bool    goodConnect = false;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start () {
    goodConnect = mysqlInit(dbConnectId, host, user, pass, dbName, port, socket, client);
    
    if ( !goodConnect ) {
        return (1); // bad connect
    }
    //      MySQL 
    // this fields are in any MySQL server
    string query = StringConcatenate(
        "SELECT `TABLE_NAME`, `TABLE_ROWS`, `CREATE_TIME`, `CHECK_TIME` ",
            "FROM `TABLES` ",
            "WHERE `TABLE_SCHEMA` = \'mysql\'");
    string data[][4];   // :       
                        // important: second dimension must be like amount of fields in your query
    int result = mysqlFetchArray(dbConnectId, query, data);
    
    if ( result == 0 ) {
        Print("0 rows selected");
    } else if ( result == -1 ) {
        Print("some error occured");
    } else {
        int rows = ArrayRange(data, 0);
        int cols = ArrayRange(data, 1);
        
        for ( int i = 0; i < rows; i++) {
            string line = "";
            
            for ( int j = 0; j < cols; j++ ) {
                line = StringConcatenate(line, data[i][j], ";");
            }
            Print(line);
        }
    }
    //+-------------------------------------------------------------------
    //|   ,      information_schema.
    //| It's just an example, nobody can insert into information_schema.
    //+-------------------------------------------------------------------
    /*string insertQuery  = StringConcatenate(
        "INSERT INTO `CHARACTER_SETS` VALUES (", "sometext"
                                        , "," , "oneMoreText"
                                        , "," , "andVarialbe"
                                        , "," , "nextWillBeNumber"
                                        , "," , 2
                                        , ")"
        );
    if ( mysqlQuery(dbConnectId, insertQuery) ) {
        Print("insert good");
    }*/
    //+-------------------------------------------------------------------
    mysqlDeinit(dbConnectId);
    return (0);
}
//+------------------------------------------------------------------+