//+------------------------------------------------------------------+
//|                                                mysql_wrapper.c++ |
//|                                Copyright  2009, Berkers Trading |
//|                                                http://quotar.com |
//+------------------------------------------------------------------+
//|                                        modified in 2012: vedroid |
//|                                                begpoug@gmail.com |
//+------------------------------------------------------------------+
#define WIN32_LEAN_AND_MEAN  // Exclude rarely-used stuff from Windows headers
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include "mysql.h"

#define MT4_EXPFUNC __declspec(dllexport)

#pragma pack(push, 1)
#pragma pack(pop)

struct MqlStr {
    int  len;
    char *string;
};
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
BOOL APIENTRY DllMain(HANDLE hModule, DWORD ul_reason_for_call, LPVOID lpReserved) {
    switch ( ul_reason_for_call ) {
        case DLL_PROCESS_ATTACH:
        case DLL_THREAD_ATTACH:
        case DLL_THREAD_DETACH:
        case DLL_PROCESS_DETACH:
            break;
    }
    return (TRUE);
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
MT4_EXPFUNC char* __stdcall mt4_mysql_wrapper_version() {
    return("mysql_wrapper v1.0.4 Copyright  2012, Berkers Trading and vedroid");
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
MT4_EXPFUNC void __stdcall mt4_mysql_fetch_row(MYSQL_RES* res, MqlStr *row, int numFields) {
    MYSQL_ROW lrow = mysql_fetch_row(res);
    
    for ( unsigned int i = 0; i < numFields; i++ ) {
  	    row[i].string = lrow[i];
	    if ( !lrow[i] ) {
		    row[i].len = 0;
	    } else {
		    row[i].len = strlen(row[i].string);
        }
    }
}
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
MT4_EXPFUNC void __stdcall mt4_mysql_fetch_fields_string(MYSQL_RES* res, MqlStr *row, int type) {
    MYSQL_FIELD *lrow = mysql_fetch_fields(res);
    
	for (unsigned int i=0; i < mysql_num_fields(res);i++){
		//MessageBox(NULL, lrow[i].name, "Application Message", MB_OK | MB_ICONINFORMATION);
		switch (type) {
			case 0: row[i].string = lrow[i].name;       /* Name of column */
				    break;
			case 1:	row[i].string = lrow[i].org_name;   /* Original column name, if an alias */
				    break;
			case 2:	row[i].string = lrow[i].table;      /* Table of column if column was a field */
				    break;
			case 3:	row[i].string = lrow[i].org_table;  /* Org table name, if table was an alias */
				    break;
			case 4:	row[i].string = lrow[i].db;         /* Database for table */
				    break;
			case 5:	row[i].string = lrow[i].catalog;	/* Catalog for table */
				    break;
			case 6:	row[i].string = lrow[i].def;		/* Default value (set by mysql_list_fields) */
				    break;
		}
		row[i].len = strlen(row[i].string);
	}
}
//+------------------------------------------------------------------+
